function onHelp()
{
  window.open('grayscaleFilterHelp.html','grayscaleThresholdFilterHelp','menubar=no,width=800,resizable=yes,toolbar=no,location=no,directories=no,status=no');
}


function onLoad()
{

  // fetch grayscaleFilter ojbect
  window.grayscaleFilter = window.arguments[0].grayscaleFilter;
	var parent = window.grayscaleFilter.parent;
	
	// set up preview window
	window.commandData = window.grayscaleFilter.commandData;
	setupPreviewWindow();  

  // extract threshold filter options into variables
  var redWeight = window.grayscaleFilter.redWeight;
  var greenWeight = window.grayscaleFilter.greenWeight;
  var blueWeight = window.grayscaleFilter.blueWeight;
  
  
  // create objects to reference the sliders 
  var redWeightSlider = document.getElementById("red-weight-slider");
  var greenWeightSlider = document.getElementById("green-weight-slider");
  var blueWeightSlider = document.getElementById("blue-weight-slider");
  
  
  // add listeners to the sliders
  redWeightSlider.addEventListener("DOMAttrModified", red_weight_slider, false);
  greenWeightSlider.addEventListener("DOMAttrModified", green_weight_slider, false);
  blueWeightSlider.addEventListener("DOMAttrModified", blue_weight_slider, false);
  
  // set inital position of sliders
  var maxpos = redWeightSlider.getAttribute("maxpos");
  redWeightSlider.setAttribute("curpos",redWeight * maxpos);
  maxpos = greenWeightSlider.getAttribute("maxpos");
  greenWeightSlider.setAttribute("curpos",greenWeight * maxpos);
  maxpos = blueWeightSlider.getAttribute("maxpos");
  blueWeightSlider.setAttribute("curpos",blueWeight * maxpos);
  
  // set initial values of textboxes
  document.getElementById("red-weight-textbox").setAttribute("value",redWeight);
  document.getElementById("green-weight-textbox").setAttribute("value",greenWeight);
  document.getElementById("blue-weight-textbox").setAttribute("value",blueWeight);


}

function onClose() {
	// do not have to destroy preview window in onClose as onCancel is called
}

function onCancel() {
	destroyPreviewWindow();
}

// Called if the user clicks OK
function onOK() {

	// apply the filter
	window.grayscaleFilter.apply_filter();

	// return false so that the window does not close
  return false;
}


function red_weight_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var redWeightSlider = document.getElementById("red-weight-slider");

  // These attributes must be specified in the xul so that they are fetchable
  redWeightSlider.maxValue = redWeightSlider.getAttribute("maxpos");
  redWeightSlider.value = redWeightSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (redWeightSlider.previousValue != redWeightSlider.value)
    {

      redWeightSlider.previousValue = redWeightSlider.value;

      // generate value between 0 and 1
      var redWeight = 1.0 * redWeightSlider.value /
	redWeightSlider.maxValue;
		
      // should use set function eventually, currently just setting value 
      window.grayscaleFilter.redWeight = redWeight;

      // update text box
      document.getElementById("red-weight-textbox").setAttribute("value",redWeight);
		

    }
}



function green_weight_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var greenWeightSlider = document.getElementById("green-weight-slider");

  // These attributes must be specified in the xul so that they are fetchable
  greenWeightSlider.maxValue = greenWeightSlider.getAttribute("maxpos");
  greenWeightSlider.value = greenWeightSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (greenWeightSlider.previousValue != greenWeightSlider.value)
    {

      greenWeightSlider.previousValue = greenWeightSlider.value;

      // generate value between 0 and 1
      var greenWeight = 1.0 * greenWeightSlider.value /
	greenWeightSlider.maxValue;
		
      // should use set function eventually, currently just setting value 
      window.grayscaleFilter.greenWeight = greenWeight;

      // update text box
      document.getElementById("green-weight-textbox").setAttribute("value",greenWeight);
		

    }
}



function blue_weight_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var blueWeightSlider = document.getElementById("blue-weight-slider");

  // These attributes must be specified in the xul so that they are fetchable
  blueWeightSlider.maxValue = blueWeightSlider.getAttribute("maxpos");
  blueWeightSlider.value = blueWeightSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (blueWeightSlider.previousValue != blueWeightSlider.value)
    {

      blueWeightSlider.previousValue = blueWeightSlider.value;

      // generate value between 0 and 1
      var blueWeight = 1.0 * blueWeightSlider.value /
	blueWeightSlider.maxValue;
		
      // should use set function eventually, currently just setting value 
      window.grayscaleFilter.blueWeight = blueWeight;

      // update text box
      document.getElementById("blue-weight-textbox").setAttribute("value",blueWeight);
		

    }
}




